
#include <stdint.h>


/// *** Defines ------------------

#define VOLUME  100 // volume level 0-100
#define EEPROM_SIZE 2
#define UDP_PRINT 0
#define UDP_PRINT2 1
#define AUDIO 1
#define DelayPeriod 2500

/// ILI9341 ---------------------


#define TFT_CS   4
#define TFT_DC   5
#define TFT_MOSI 23
#define TFT_CLK  18
#define TFT_RST  16
#define TFT_MISO 19
#define TFT_LED  17

#define I2S_DOUT      25  // DIN connection
#define I2S_LRC       26  // Left Right Clock
#define I2S_BCLK      27  // Bit clock

#define BgrColor ILI9341_NAVY

//// XTR2046 TouchPad
#define TouchPins 1
#define TOUCH_IRQ_PIN      34
#if  TouchPins 
#define TOUCH_OUT          32 
#define TOUCH_DIN          35
#else
#define TOUCH_OUT          35 
#define TOUCH_DIN          32
#endif
#define TOUCH_CS_PIN       33 
#define TOUCH_CLK          12

#define TFT_NORMAL          1
#define TFT_UPSIDEDOWN      3

#define INI_FILENAME "/radio.ini"
#define SendUDPPackets UdpPrint

#define BuCount 7



// WiFi Stuff ************************************
// Set your Static IP address
IPAddress local_IP(192, 168, 1, 232);
// Set your Gateway IP address
IPAddress gateway(192, 168, 1, 1);

IPAddress subnet(255, 255, 255, 0);
IPAddress primaryDNS(8, 8, 8, 8);   //optional
IPAddress secondaryDNS(8, 8, 4, 4); //optional


char ssid[] = "MOVISTAR_96E1";            //  your network SSID (name) 
char pass[] = "MkNyxnxGUHkulcCWY9zs";       // your network password
#define OTA_PASS "Martin-MIchael"

#define UdpPort 3334
const char * UdpAddress = "192.168.1.34";
// Variables

uint32_t interval = 1000; 
uint32_t SECONDS_TO_AUTOSAVE = 30;
uint32_t seconds = 0;
uint32_t previousMillis = 0; 

int radioStation = 0;
int previousRadioStation = -1;
// etc *************************************
uint8_t mp3buff[32];   // vs1053 likes 32 bytes at a time


/**************************************************************
/  @param  Strings
***************************************************************/

String Text1, OldText1; 
String ESP_COMMAND;    
String HTML_Button[] = {"BuPrev","BuNext","BuVol_p","BuVol_m","BuMute","BuStatus","BuDelete"};
String StationTabel;
String StreamTitle; 

const char* PARAM_INPUT_1 = "output";
const char* PARAM_INPUT_2 = "state";
const char* PARAM_INPUT_3 = "table";

const int BufferLen = 100;
char Buffer[100];



//some global variables




uint8_t max_volume   = 21;
uint8_t max_stations = 126;

int8_t  cur_station  = 0;   //current station(nr), will be set later 
int16_t cur_volume   = 0;   //will be set from stored preferences
int8_t  cur_btn      =-1;   //current button (, -1 means idle)

enum action{VOLUME_UP=0, VOLUME_DOWN=1, STATION_UP=2, STATION_DOWN=3};
enum staus {RELEASED=0, PRESSED=1};

struct _btns{
    uint16_t x; //PosX
    uint16_t y; //PosY
    uint16_t w; //Width
    uint16_t h; //Hight
    uint8_t  a; //Action
    uint8_t  s; //Status
};

typedef _btns btns;

btns btn[4];



/*************************************************************
/  @param  Enum
*************************************************************/
enum Station_e { StationList_HTML, StationList_Spiff   } Station;
enum HTML_Bu_e { BuPrev, BuNext, BuVol_p, BuVol_m, BuMute, BuStatus, BuDelete, BuNone } HTML_Bu;

/*************************************************************
/  @param  struct
*************************************************************/

struct Radio_t
{
String url;
String Name;

} _Radio;

struct Stations_t
{
std::vector<String> url;   
std::vector<String> Name;   
int Entries = 0;

} _Stations;



/************************************************************************************
/  @param  Boolean
*************************************************************************************/
bool bWiFiConnected = false;
bool bWinSocketSend1 = true;
bool bChangeSender = false;
bool bSetVolume = false;
bool bSetNewStationName = false;
bool bSetNewStationURL = false;
bool bDeleteStation = false;
bool bStreamTitle  = false;

/************************************************************************************
/  @param  Integers
*************************************************************************************/

uint32_t ClientID = 0;
uint32_t _DelayNow = 0;







